/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: SharedToPointerIterator.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _UTILITY_SHARED_TO_POINTER_ITERATOR_HPP_
#define _UTILITY_SHARED_TO_POINTER_ITERATOR_HPP_

namespace Utility {

	/**
	 * shared_ptr<T>を持つ反復子をT*の反復子に変換します。
	 *
	 * @author トゥイー
	 */
	template<class Iterator, class ValueType>
	class SharedToPointerIterator {
	private:
		/**
		 * ラップする反復子です。
		 */
		Iterator m_i;

	public:
		/**
		 * ラッパーを構築します。
		 */
		SharedToPointerIterator(Iterator i) : m_i(i) {
		}

	public:
		/**
		 * 反復子を(前置)インクリメントします。
		 */
		SharedToPointerIterator<Iterator, ValueType>& operator++() {
			++m_i;
			return *this;
		}

		/**
		 * 反復子を(後置)インクリメントします。
		 */
		SharedToPointerIterator<Iterator, ValueType>& operator++(int dummy) {
			++m_i;
			return *this;
		}

		/**
		 * 反復子の内容を取得します。
		 */
		ValueType* operator*() const {
			return (*m_i).get();
		}

	public:
		/**
		 * 等号判定です。
		 */
		bool operator==(const SharedToPointerIterator<Iterator, ValueType>& i) {
			return m_i == i.m_i;
		}

		/**
		 * 不等号判定です。
		 */
		bool operator!=(const SharedToPointerIterator<Iterator, ValueType>& i) {
			return m_i != i.m_i;
		}
	};

	/**
	 * shared_ptr<T>を持つ定数反復子をconst T*の定数反復子に変換します。
	 *
	 * @author トゥイー
	 */
	template<class ConstIterator, class ValueType>
	class ConstSharedToPointerIterator {
	private:
		/**
		 * ラップする反復子です。
		 */
		ConstIterator m_i;

	public:
		/**
		 * ラッパーを構築します。
		 */
		ConstSharedToPointerIterator(ConstIterator i) : m_i(i) {
		}

	public:
		/**
		 * 反復子を(前置)インクリメントします。
		 */
		ConstSharedToPointerIterator<ConstIterator, ValueType>& operator++() {
			++m_i;
			return *this;
		}

		/**
		 * 反復子を(後置)インクリメントします。
		 */
		ConstSharedToPointerIterator<ConstIterator, ValueType>& operator++(int dummy) {
			++m_i;
			return *this;
		}

		/**
		 * 反復子の内容を取得します。
		 */
		ValueType* const operator*() const {
			return (*m_i).get();
		}

	public:
		/**
		 * 等号判定です。
		 */
		bool operator==(const ConstSharedToPointerIterator<ConstIterator, ValueType>& i) {
			return m_i == i.m_i;
		}

		/**
		 * 不等号判定です。
		 */
		bool operator!=(const ConstSharedToPointerIterator<ConstIterator, ValueType>& i) {
			return m_i != i.m_i;
		}
	};

}  // namespace Utility

#endif
